<?php
require_once 'base.php';

require_once $GLOBALS['babAddonPhpPath']."functions.php";

function is_regular_mail($email)
{
   $syntax='#^[\w.-]+@[\w.-]+\.[a-zA-Z]{2,6}$#'; 
   if(preg_match($syntax,$email))
   {
		return true;
	}
	else
	{
		return false;
	}
}

function displayReportForm()
{
	global $babBody;
	class displayReportFormClass
	{
		function displayReportFormClass()
		{
			global $babDB;
			global $babBody;
			global $babSiteName;
			$res = $babDB->db_query("
			SELECT 
			`adminemail`, 
			`adminname`
			FROM
			`bab_sites`
			WHERE
			`name` = '".$babDB->db_escape_string($babSiteName)."'
			");
			list($this->from, $this->from_name) = $babDB->db_fetch_row($res);
			$this->subject = undecode_html(bab_translate("Login modified on:", $GLOBALS['babAddonFolder']))." ".$babSiteName;
			$this->mail_notification = false;
			if (bab_pp('user_information', '0') === '1') $this->mail_notification = true;
			$this->send_label = undecode_html(bab_translate("Notification", $GLOBALS['babAddonFolder']));
			$this->success_label = undecode_html(bab_translate("Successfull delivery", $GLOBALS['babAddonFolder']));
			$this->fail_label = undecode_html(bab_translate("No message", $GLOBALS['babAddonFolder']));
			$this->no_change_label = undecode_html(bab_translate("No change", $GLOBALS['babAddonFolder']));
			$this->print_label = undecode_html(bab_translate("Print", $GLOBALS['babAddonFolder']));
			$this->full_name_label = undecode_html(bab_translate("Full name", $GLOBALS['babAddonFolder']));
			$this->nickname_label = undecode_html(bab_translate("New nickname", $GLOBALS['babAddonFolder']));
			$this->email_label = undecode_html(bab_translate("Email", $GLOBALS['babAddonFolder']));
			$this->bgcolor = true;
			$this->user_id_array = bab_pp('user_id', array());
			$this->convert_to_low_case_array = bab_pp('convert_to_low_case', array());
			$this->count = count($this->convert_to_low_case_array);
			if ($this->count > 0)
			{
				$this->conversion_flag = true;
			}
			else
			{
				$this->conversion_flag = false;
				$babBody->addError(undecode_html(bab_translate("No conversion has been proceed", $GLOBALS['babAddonFolder'])));
			}
		}
		function next()
		{
			global $babDB;
			global $babInstallPath;
			static $k=0;
			if( $k < $this->count)
			{
				$indice = $this->convert_to_low_case_array[$k];
				$user_id = $this->user_id_array[$indice];
				$this->full_name = bab_getUserName($user_id);
				$this->old_nickname = bab_getUserNickname($user_id);
				$this->new_nickname = mb_strtolower($this->old_nickname);
				$this->email = bab_getUserEmail($user_id);
				$error = false;
				$this->status = bab_updateUserNicknameById($user_id, $this->new_nickname, true, $error);
				if ($this->status === false) $this->new_nickname = $this->old_nickname;
				$this->send_flag = false;
				if (($this->email != DEFAULT_MAIL) && is_regular_mail($this->email) && $this->status && $this->mail_notification)
				{
					include_once $babInstallPath."utilit/mailincl.php";
					$mail = bab_mail();
					if ($mail) 
					{
						$mail->ClearTo();
						$mail->mailFrom($this->from, $this->from_name);
						$mail->mailTo($this->email, $this->full_name);
						$mail->mailSubject($this->subject);
						$html_content = undecode_html(bab_translate("Your nickname on the site was modified.", $GLOBALS['babAddonFolder']));
						$html_content .= "<br>";
						$html_content .= undecode_html(bab_translate("Your new nickname is:", $GLOBALS['babAddonFolder']));
						$html_content .= "<br>";
						$html_content .= "<b>".$this->new_nickname."</b>";
						$html_content .= "<br>";
						$html_content .= undecode_html(bab_translate("Please note that your nickname is case sensitive.", $GLOBALS['babAddonFolder']));
						$html_content .= "<br>";
						$html_content .= undecode_html(bab_translate("Please note also that your password has no change.", $GLOBALS['babAddonFolder']));
						$mail->mailBody($mail->mailTemplate($html_content));
						$txt_content = undecode_html(bab_translate("Your nickname on the site was modified.", $GLOBALS['babAddonFolder']));
						$txt_content .= "\r\n";
						$txt_content .= undecode_html(bab_translate("Your new nickname is:", $GLOBALS['babAddonFolder']))." ".$this->new_nickname;
						$txt_content .= "\r\n";
						$txt_content .= undecode_html(bab_translate("Please note that your nickname is case sensitive.", $GLOBALS['babAddonFolder']));
						$txt_content .= "\r\n";
						$html_content .= undecode_html(bab_translate("Please note also that your password has no change.", $GLOBALS['babAddonFolder']));
						$txt_content = html_entity_decode($txt_content, ENT_NOQUOTES, "ISO-8859-15");
						$mail->mailAltBody($txt_content);
						if ($mail->send() != false) $this->send_flag = true;
					}
				}
				$this->bgcolor = !$this->bgcolor;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new displayReportFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."admin.html", "report_form"));
}


function displaySelectionForm()
{
	global $babBody;
	class displaySelectionFormClass
	{
		function displaySelectionFormClass()
		{
			global $babDB;
			global $babBody;
			global $babInstallPath;
			$this->nickname_label = undecode_html(bab_translate("Nickname", $GLOBALS['babAddonFolder']));
			$this->lastname_label = undecode_html(bab_translate("Lastname", $GLOBALS['babAddonFolder']));
			$this->firstname_label = undecode_html(bab_translate("Firstname", $GLOBALS['babAddonFolder']));
			$this->email_label = undecode_html(bab_translate("Email", $GLOBALS['babAddonFolder']));
			$this->validate_label = undecode_html(bab_translate("Validate", $GLOBALS['babAddonFolder']));
			$this->reset_label = undecode_html(bab_translate("Reset", $GLOBALS['babAddonFolder']));
			$this->mail_enabled = bab_mail();
			$this->user_information = undecode_html(bab_translate("Send the new nicknames by mail", $GLOBALS['babAddonFolder']));
			$this->user_information_tooltip = undecode_html(bab_translate("Only the users with a valid adress with be mailed", $GLOBALS['babAddonFolder']));
			$this->select_all_label = undecode_html(bab_translate("Select all", $GLOBALS['babAddonFolder']));
			$this->unselect_all_label = undecode_html(bab_translate("Unselect all", $GLOBALS['babAddonFolder']));$this->bgcolor = true;
			$res = $babDB->db_query("
			SELECT
			`id`,
			`nickname`,
			`lastname`,
			`firstname`,
			`email` 
			FROM
			`bab_users`
			");
			$this->count = $babDB->db_num_rows($res);
			$i = 0;
			$this->is_usefull = false;
			while (($arr = $babDB->db_fetch_array($res)) && !$this->is_usefull)
			{
				$nickname = $arr['nickname'];
				if ($nickname != mb_strtolower($nickname, CHARSET)) $this->is_usefull = true;
				$i++;
			}
			if ($this->is_usefull === true)
			{
				$babBody->addError(undecode_html(bab_translate("Select the users whose nickname must be converted", $GLOBALS['babAddonFolder'])));
				$this->res = $babDB->db_query("
				SELECT
				`id`,
				`nickname`,
				`lastname`,
				`firstname`,
				`email`
				FROM
				`bab_users`
				ORDER BY
				`lastname`,
				`firstname`
				");
				$this->indice = 0;
			}
			else
			{
				$babBody->addError(undecode_html(bab_translate("No conversion is needed", $GLOBALS['babAddonFolder'])));
			}			
		}
		
		function next()
		{
			global $babDB;
			static $k=0;
			if( $k < $this->count)
			{
				$arr = $babDB->db_fetch_array($this->res);
				$this->nickname = $arr['nickname'];
				$this->email = $arr['email'];
				$this->skip = false;
				
				if ($this->nickname == mb_strtolower($this->nickname))
				{
					$this->skip = true;
				}
				else
				{
					$this->indice++;
					$this->user_id = $arr['id'];
					$this->lastname = $arr['lastname'];
					$this->firstname = $arr['firstname'];
					$this->email = $arr['email'];
					if (is_possible_administrator_or_manager($this->nickname) && is_administrators_or_managers_groups_member($this->user_id)) $this->checked_flag = ''; else $this->checked_flag = 'checked="checked"';
					$this->bgcolor = !$this->bgcolor;
				}
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
		
		function next2()
		{
			return true;
		}
	}
	$obj= new displaySelectionFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."admin.html", "selection_form"));
}

$idx = bab_rp('idx', 'select');

switch($idx)
{
	case 'proceed':
		if( bab_isUserAdministrator())
		{
			$babBody->title = undecode_html(bab_translate("Report of setting nicknames to low case", $GLOBALS['babAddonFolder']));
			displayReportForm();
		}
		break;
	case 'select':
	default:
		if( bab_isUserAdministrator())
		{
			$babBody->title = undecode_html(bab_translate("Setting nicknames to low case", $GLOBALS['babAddonFolder']));
			displaySelectionForm();
		}
		break;
}

$babBody->setCurrentItemMenu($idx);

?>
