<?php

	// Inclusion de deux fichiers du module gestutilisateurs
	require_once $GLOBALS['babInstallPath'].'addons'.DIRECTORY_SEPARATOR.'gestutilisateurs'.DIRECTORY_SEPARATOR.'functions.php';
	require_once $GLOBALS['babInstallPath'].'addons'.DIRECTORY_SEPARATOR.'gestutilisateurs'.DIRECTORY_SEPARATOR.'gestutilisateurs_ini.php';
	
	// Dfinition de l'encodage utilis
	if (!defined("CHARSET"))
	{
		switch (mb_strtolower(mysql_client_encoding()))
		{
			case "utf8":
				define("CHARSET", "UTF-8");
				break;
			case 'latin1':
			default:
				define ("CHARSET", "ISO-8859-15");
				break;
		}
	}

	// Dcodage HTML
	if (!function_exists('undecode_html'))
	{
		function undecode_html($string)
		{
			return html_entity_decode($string, ENT_QUOTES, CHARSET);
		}
	}
	
	// Dfinition de l'id du groupe des gestionnaires de l'tablissement
	if (!defined("MANAGERS_GROUP_ID"))
	{
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_groups`
		WHERE
		`name` = '".$babDB->db_escape_string(ETABGEST_GROUP_NAME)."'
		AND
		`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
		");
		if ($babDB->db_num_rows($res) > 0)
		{
			$arr = $babDB->db_fetch_array($res);
			define("MANAGERS_GROUP_ID", $arr['id']);
		}
	}
	
	// Dfinition de l'id du groupe des administrateurs dlgus
	if (!defined("DELEGATED_ADMINISTRATORS_GROUP_ID"))
	{
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_groups`
		WHERE
		`name` = '".$babDB->db_escape_string(ADMINS_GROUP_NAME)."'
		AND
		`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
		");
		if ($babDB->db_num_rows($res) > 0)
		{
			$arr = $babDB->db_fetch_array($res);
			define("DELEGATED_ADMINISTRATORS_GROUP_ID", $arr['id']);
		}
	}
	
	// Dfinition de l'id du groupe des gestionnaires dlgus
	if (!defined("DELEGATED_MANAGERS_GROUP_ID"))
	{
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_groups`
		WHERE
		`name` = '".$babDB->db_escape_string(GESTS_GROUP_NAME)."'
		AND
		`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
		");
		if ($babDB->db_num_rows($res) > 0)
		{
			$arr = $babDB->db_fetch_array($res);
			define("DELEGATED_MANAGERS_GROUP_ID", $arr['id']);
		}
	}
	
	// Recherche des comptes des administrateurs ou des gestionnaires
	if (!function_exists('is_administrators_or_managers_groups_member'))
	{
		function is_administrators_or_managers_groups_member($user_id)
		{
			$arr = array(BAB_ADMINISTRATOR_GROUP, MANAGERS_GROUP_ID, DELEGATED_ADMINISTRATORS_GROUP_ID, DELEGATED_MANAGERS_GROUP_ID);
			
			foreach ($arr as $group_id)
			{
				if (bab_isMemberOfGroup($group_id, $user_id)) return(true);
			}
			return(false);
		}
	}
	
	// Recherche des comptes des administrateurs ou des gestionnaires
	if (!function_exists('is_possible_administrator_or_manager'))
	{
		function is_possible_administrator_or_manager($nickname)
		{
			$arr = array(ADMIN_FIRSTNAME, GEST_FIRSTNAME);
			
			foreach ($arr as $value)
			{
				$nickname_begin = mb_substr($nickname, 0, 1, CHARSET);
				$nickname_end = mb_substr($nickname, mb_strlen($nickname, CHARSET) - mb_strlen($value, CHARSET), mb_strlen($value, CHARSET), CHARSET);
				if ((mb_strtoupper($nickname_begin, CHARSET) === $nickname_begin) && ($nickname_end === $value)) return(true);
			}
			
			return(false);
		}
	}

?>